package x86

import "git.urbach.dev/cli/q/src/cpu"

const (
	R0 cpu.Register = iota // RAX
	R1                     // RCX
	R2                     // RDX
	R3                     // RBX
	SP                     // Stack pointer
	R5                     // RBP
	R6                     // RSI
	R7                     // RDI
	R8
	R9
	R10
	R11
	R12
	R13
	R14
	R15
	TMP = R1
)

var (
	SyscallInputRegisters    = []cpu.Register{R0, R7, R6, R2, R10, R8, R9}
	WindowsInputRegisters    = []cpu.Register{R1, R2, R8, R9}
	WindowsOutputRegisters   = []cpu.Register{R0}
	WindowsVolatileRegisters = []cpu.Register{R1, R2, R8, R9, R10, R11}

	CPU = cpu.CPU{
		General:       []cpu.Register{R3, R12, R13, R14, R15, R11},
		Input:         SyscallInputRegisters,
		Output:        SyscallInputRegisters,
		SyscallInput:  SyscallInputRegisters,
		SyscallOutput: []cpu.Register{R0, R1, R11},
		NumRegisters:  16,
	}
)
